/********************************** (C) COPYRIGHT *******************************
 * File Name          : Main.c
 * Author             : WCH
 * Version            : V1.0
 * Date               : 2020/08/06
 * Description        : ԶUSB豸CH372豸ṩ80ͨ(ϴ+´)ʵ´Ȼȡϴ
 *******************************************************************************/
#define DBG_TAG "main"
#define DBG_LVL DBG_LOG
#include "CH57x_common.h"
#include "dbg.h"
#include "usb_cdc.h"
#include "shell.h"
#include "shell_cmd.h"
#include "MCUKeys.h"
#include "my_uart.h"
#include "my_misc.h"




SHELL_TypeDef shell;
unsigned int systick = 0;

unsigned int get_systick(void)
{
  return systick;
}

/**
 * USB<-->ݴ
*/
void usb_uart_comm_handle(void)
{
  uint8_t len = 0;
  static uint8_t tempbuf[128] = {0};
  len = ring_buffer_num_items(&usb_to_uart_rb);
  if (len != 0)
  {
    ring_buffer_dequeue_arr(&usb_to_uart_rb, tempbuf, len);
    UART0_SendString(tempbuf, len);
  }

  len = ring_buffer_num_items(&uart_to_usb_rb);
  if (len != 0)
  {
    len = len >= 64 ? 64 : len;
    ring_buffer_dequeue_arr(&uart_to_usb_rb, pEP2_IN_DataBuf, len);
    DevEP2_IN_Deal(len);
  }
}

int main()
{
  uint8_t uart1Recv = 0;
  event_key e_key;
  char data;
  SetSysClock(CLK_SOURCE_PLL_60MHz);

  my_misc_init();
  DebugInit();
  uart0_init();
  shell.write = shell_write_cb;
  shellInit(&shell);
  usb_cdc_init();
  PFIC_EnableIRQ(USB_IRQn);
  PFIC_EnableIRQ(UART1_IRQn);
  PFIC_EnableIRQ(UART0_IRQn);
  for (;;)
  {
    DelayMs(10);
    //key_scan();
    usb_uart_comm_handle();
    //systick++;
    //e_key = key_out_fifo();
  }
}

__attribute__((interrupt("WCH-Interrupt-fast")))
__attribute__((section(".highcode"))) void
USB_IRQHandler(void) /* USBжϷ,ʹüĴ1 */
{
  USB_DevTransProcess();
}

__attribute__((interrupt("WCH-Interrupt-fast")))
__attribute__((section(".highcode"))) void
UART1_IRQHandler(void)
{
  uint8_t i;
  switch (UART1_GetITFlag())
  {
  case UART_II_LINE_STAT: // ·״̬
  {
    UART1_GetLinSTA();
    break;
  }

  case UART_II_RECV_RDY: // ݴﵽô
  {
    shellInput(&shell, UART1_RecvByte());
  }
  break;

  case UART_II_RECV_TOUT: // ճʱʱһ֡ݽ

    break;

  case UART_II_THR_EMPTY: // ͻգɼ
    break;

  case UART_II_MODEM_CHG: // ִֻ֧0
    break;

  default:
    break;
  }
}
