#include "CH57x_common.h"
#include "my_misc.h"
#include "MCUKeys.h"


static key my_key[KEY_ID_MAX];
static uint8_t get_key_state_cb(const event_key e_key)
{
  uint8_t ret = KEY_LIFT;
  switch (e_key.id)
  {
  case KEY_ID_UP:
  {
    if (GPIOA_ReadPortPin(KEY0_Pin) == GPIO_PIN_RESET)
    {
      ret = KEY_PRESS;
    }
    else
    {
      ret = KEY_LIFT;
    }
  }
  break;
  case KEY_ID_DOWN:
  {
    if (GPIOA_ReadPortPin(KEY1_Pin) == GPIO_PIN_RESET)
    {
      ret = KEY_PRESS;
    }
    else
    {
      ret = KEY_LIFT;
    }
  }
  break;
  case KEY_ID_LEFT:
  {
    if (GPIOA_ReadPortPin(KEY2_Pin) == GPIO_PIN_RESET)
    {
      ret = KEY_PRESS;
    }
    else
    {
      ret = KEY_LIFT;
    }
  }
  break;
  case KEY_ID_RIGHT:
  {
    if (GPIOA_ReadPortPin(KEY3_Pin) == GPIO_PIN_RESET)
    {
      ret = KEY_PRESS;
    }
    else
    {
      ret = KEY_LIFT;
    }
  }
  break;
  // case KEY_ID_ENTER:
  // {
  //     if (GPIOA_ReadPortPin( KEY4_Pin) == GPIO_PIN_RESET)
  //     {
  //         ret = KEY_PRESS;
  //     }
  //     else
  //     {
  //         ret = KEY_LIFT;
  //     }
  // }
  // break;
  default:
    break;
  }
  return ret;
}

static void key_init_pre(void)
{
  GPIOA_ModeCfg(GPIO_Pin_4, GPIO_ModeIN_PU);
  GPIOA_ModeCfg(GPIO_Pin_5, GPIO_ModeIN_PU);
  GPIOA_ModeCfg(GPIO_Pin_14, GPIO_ModeIN_PU);
  GPIOA_ModeCfg(GPIO_Pin_13, GPIO_ModeIN_PU);

  for (int i = 0; i < (KEY_ID_MAX); i++)
  {
    key_init(&my_key[i]);
    my_key[i].e_key.id = i;
    my_key[i].key_event_cb = NULL; // 屏蔽这行表示不使用事件回调函数
    my_key[i].get_key_status = get_key_state_cb;
    key_add(&my_key[i]);
  }
}




void my_misc_init(void)
{
    key_init_pre();
}






















